﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Epr
{
    public class Particle
    {
        public Particle()
        {
            //The particle is initiated with a random polarization angle
            this.Polarization = h.GetRandomTwoPiAngle();
        }
        private double _Polarization = 0;
        public double Polarization
        {
            get
            {
                return _Polarization;
            }
            set
            {
                _Polarization = value;
            }
        }
       private double _DelayTime = 0;
       /// <summary>
       /// Is used in de Readt model
       /// </summary>
       public double DelayTime
       {
           get
           {
               return _DelayTime;
           }
           set
           {
               _DelayTime = value;
           }
       }
       private bool _Absorbed = false;
       /// <summary>
       /// Absorbed: interpreted as aiming for the detector 1, while not absorbed is counted at
       /// the  detector 2
       /// </summary>
       public bool Absorbed
       {
           get
           {
               return _Absorbed;
           }
           set
           {
               _Absorbed = value;
           }
       }
       public int Passed
       {
           get
           {
               if (this.Absorbed)
               {
                   return 0;
               }
               return 1;
           }
       }

    }
}
