﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Epr
{
    /// <summary>
    /// Helper functions, to give more easily access to certain math
    /// </summary>
    public static class h
    {
        public static double SinSquare(double Angle)
        {
            double sin = Math.Sin(Angle);
            return sin * sin;
        }
        public static double CosSquare(double Angle)
        {
            double cos = Math.Cos(Angle);
            return cos * cos;
        }
        public static double Sin(double Angle)
        {
            return Math.Sin(Angle);
        }
        public static double Cos(double Angle)
        {
            return Math.Cos(Angle);
        }
        public static double Pi = Math.PI;
        public static double PiOver2 = Math.PI / 2;
        public static double PiOver4 = Math.PI / 4;
        public static double PiOver8 = Math.PI / 8;
        public static double TwoPi = Math.PI * 2;
        public static Random r = new Random(DateTime.Now.Millisecond);
        public static double GetRandom()
        {
            return r.NextDouble();
        }
        public static double GetRandomPlusMin()
        {
            return r.NextDouble()*2-1;
        }
        public static double GetRandomTwoPiAngle()
        {
            return h.TwoPi * r.NextDouble();
        }
        public static double GetRandomPiAngle()
        {
            return h.Pi * r.NextDouble();
        }
        public static double GetRandomPlusMinPiAngle()
        {
            return GetRandomTwoPiAngle()-h.Pi;
        }
        public static double GetAngleAsPi(double AngleInDegrees)
        {
            return (AngleInDegrees/180) * h.Pi;
        }
        public static double Malus(double Angle)
        {
            return Cos(2 * Angle);
        }
        public static bool MalusAbsorbed(double Angle)
        {
            double malus = Malus(Angle);
            double random = GetRandom();
            if (malus > random)
            {
                return true;
            }
            return false;
        }
        public static int GetRandom0to3()
        {
            return r.Next(4);
        }
        public static double Mod(double Value, double Modulo)
        {
            return Value % Modulo;
        }
    }
}
